"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatSnapshot = exports.invertSnapshot = exports.formatTagType = void 0;
const formatTagType = (type) => {
    var _a, _b;
    if ((_a = type.type) === null || _a === void 0 ? void 0 : _a.name) {
        // let res = await prisma.programType.findFirst({ where: { id: root.type.typeId, programId: root.programId } });
        return (_b = type.type) === null || _b === void 0 ? void 0 : _b.name;
    }
    else if (type === null || type === void 0 ? void 0 : type.scalar) {
        return type === null || type === void 0 ? void 0 : type.scalar;
    }
};
exports.formatTagType = formatTagType;
const invertSnapshot = (snapshot, tags) => {
    const typedSnapshot = tags === null || tags === void 0 ? void 0 : tags.reduce((prev, tag) => {
        let typeName = tag.type; //types?.find((a) => a.id == tag.type?.typeId)?.name;
        if (!typeName)
            return prev;
        return Object.assign(Object.assign({}, prev), { [typeName]: Object.assign(Object.assign({}, (prev[typeName] || {})), { [tag.name]: snapshot[tag.name] }) });
    }, {});
    return typedSnapshot;
};
exports.invertSnapshot = invertSnapshot;
const formatSnapshot = (tags, types, values) => {
    let valueObj = values.reduce((prev, curr) => {
        let key = curr.key;
        let update = {};
        if (key) {
            update = Object.assign(Object.assign({}, prev[curr.placeholder]), { [key]: curr.value });
        }
        else {
            update = curr.value;
        }
        return Object.assign(Object.assign({}, prev), { [curr.placeholder]: update });
    }, {});
    return tags === null || tags === void 0 ? void 0 : tags.map((tag) => {
        var _a;
        let type = (types === null || types === void 0 ? void 0 : types.find((a) => a.name === tag.type)) || tag.type;
        let hasFields = (typeof type != 'string' && (type === null || type === void 0 ? void 0 : type.fields) || []).length > 0;
        let value = valueObj[tag.name];
        if (type &&
            typeof (type) === "string" &&
            type.indexOf('[]') > -1) {
            if (typeof (value) === "object" &&
                !Array.isArray(value) &&
                Object.keys(value).map((x) => x % 1 == 0).indexOf(false) < 0) {
                value = Object.keys(value).map((x) => value[x]);
            }
            else if (typeof (value) === 'string') {
                value = value.split(',');
            }
        }
        else if (typeof type != 'string' && hasFields) {
            (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach((field) => {
                if (field.type &&
                    value &&
                    value[field.name] &&
                    typeof (field.type) === "string" &&
                    field.type.indexOf('[]') > -1) {
                    if (typeof (value[field.name]) === "object" &&
                        !Array.isArray(value[field.name]) &&
                        Object.keys(value[field.name]).map((x) => x % 1 == 0).indexOf(false) < 0) {
                        value[field.name] = Object.keys(value[field.name]).map((x) => value[field.name][x]);
                    }
                    else if (typeof (value[field.name]) === 'string') {
                        value[field.name] = value[field.name].split(',');
                    }
                }
            });
        }
        return {
            key: `${tag.name}`,
            value: value
        };
    }).reduce((prev, curr) => (Object.assign(Object.assign({}, prev), { [curr.key]: curr.value })), {});
};
exports.formatSnapshot = formatSnapshot;
